//
// italkpipe.cc
//

#include "socket-stream.h"
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <signal.h>
#include <locale.h>


int typecmp(char *str1, char *str2)
     /* str1 Υե̾ str2 ƤϤޤ뤫Ĵ٤롣
        ƤϤޤ True ƤϤޤʤ False
        ex. str1="files.txt" str2="*.t??" ʤɡ*/
{
  if (!str1 || !str2) return False;
  while (1)
  {
    if (!*str1)
    {
      if (!*str2) return True;
      if (*str2=='*' && !*(str2+1)) return True;
      return False;
    }
    if (!*str2) return False;
    else if (*str2=='*')
    {
      str2++;
      if (!*str2) return True;
      while (1)
      {
        if (typecmp(str1, str2)) return True;
        str1++;
        if (!*str1) return False;
      }
    }
    else if (tolower(*str1)==tolower(*str2) || *str2=='?')
    {
      str1++;
      str2++;
      continue;
    }
    return False;
  }
}


void split_host_port(char * const host_port, char *&host_r, US &port_r)
{
  static char buf[BUFSIZE];
  char *c=strchr(host_port, ':');
  if (c)
  {
    strncpy(buf, host_port, int(c-host_port));
    buf[int(c-host_port)]='\0';
    port_r=atoi(c+1);
  }
  else
  {
    strcpy(buf, host_port);
    port_r=12345;
  }
  host_r=buf;
  return;
}


char *firstperiod(char *host)
{
  static char h[BUFSIZE];
  char *a=strchr(host, '@');
  char *c;
  if (!a) a=host;
  c=strchr(a, '.');
  if (c)
  {
    strncpy(h, host, c-host);
    h[c-host]='\0';
  }
  else strcpy(h, host);
  return h;
}


char *Munou1[]= // ѷбƤʤ
{
  "Ϥ",
  "nani-",
  "ѷ",
  "ְ淯",
  "HAL-3",
  "̵Ǿ1",
  "]",
};


char *Munou2[]= // ѷбƤ
{
  "ƣ",
  "̵Ǿ2",
};


#define MAX_MEMBER 30


class Italk;


class AnItalk
{
  friend class Italk;

  US port;
  Italk *italk;
  
  int now_backlog;
  char *hostname;
  char *members[MAX_MEMBER];
	int members_num[MAX_MEMBER];
  int italkpipe_number;
  char *p_mode_who;

public:
  SocketStream soc;
  int Connect(char *to);
  AnItalk(Italk *_italk);
  ~AnItalk();
  void Receive(void);
  int GetMembersNum(char *name);
  int Command(char *who, char *command);
};


class Italk
{
  AnItalk *anitalk[MAX_FD];
  int client[MAX_FD];
  
  SocketStream server;
  int n;
  int get_members_n;
  int get_members_host_fd;
  int chukei_message_counter;
  static char *chukei_message[];
  
public:
  Italk(int port);
  ~Italk(void);
  int Open(char *to);
  void Close(int fd);
  void Close(char *with, int fd);
  void Wait(void);
  void SendAll(char *buf, int fd);
  char *GetMembers(char *host, AnItalk **ai=NULL);
  void SendToClientWhoAreHere(int f);
  char *GetChukeiMessage(void);
};


AnItalk::AnItalk(Italk *_italk)
{
  italk=_italk;
  now_backlog=False;
  hostname=NULL;
  italkpipe_number=0;
  p_mode_who=NULL;
  for (int i=0; i<MAX_MEMBER; i++)
  {
    members[i]=NULL;
    members_num[i]=-1;
  }
}


AnItalk::~AnItalk()
{
  delete_string(hostname);
  for (int i=0; i<MAX_MEMBER; i++)
    delete_string(members[i]);
}



int AnItalk::GetMembersNum(char *name)
{
  for (int i=0; i<MAX_MEMBER; i++)
  {
    if (members[i])
    {
      if (0==strncmp(members[i], name, strchr(members[i], '@')-members[i]))
	return members_num[i];
    }
  }
  return -1;
}


int AnItalk::Connect(char *to)
{
  char *host;
  split_host_port(to, host, port);
  
  fprintf(stderr, "connecting to %s:%u\r\n", host, port);
  
  if (soc.Init(SOCKET_STREAM_CLIENT, host, port, True, 15))
    return -1;
  
  delete_string(hostname);
  hostname=new_string(host);
  
  char buf[BUFSIZE];
  sprintf(buf, "ѷ\r\n");
  soc.Puts(soc.SocketFD(), buf);
  soc.Puts(soc.SocketFD(), "/w\r\n");
  
  return soc.SocketFD();
}



int AnItalk::Command(char *who, char *command)
{
  int i;

//	fprintf(stderr, "%s|%s|\n", who, command);
  
  // ѷб̵Ǿä顢Ѥʤ
  for (i=0; i<sizeof(Munou1)/sizeof(char *); i++)
    if (0==strncmp(who, Munou1[i], strlen(Munou1[i]))) return False;
  
  // ѷб̵ǾΥޥɤˤȿʤ
  for (i=0; i<sizeof(Munou2)/sizeof(char *); i++)
    if (0==strncmp(who, Munou2[i], strlen(Munou2[i]))) return True;
  
  if (i==sizeof(Munou2)/sizeof(char *))
  {
    if (typecmp(command, "**"))
    {
      char *send=italk->GetChukeiMessage();
      italk->SendAll(send, -1);
    }
    
    else if (typecmp(command, "w@*"))
    {
      char *h=strchr(command, '@')+1;
      int n=GetMembersNum(who);
      if (n!=-1)
      {
	char *_who;
	italk->GetMembers(NULL);
	char host[BUFSIZE];
	sprintf(host, "%s*", h);
	AnItalk *ai;
	while (_who=italk->GetMembers(host, &ai))
	{
	  char send[BUFSIZE];
	  sprintf(send, "/p %04d %s (@", n, _who);
	  strcat(send, firstperiod(ai->hostname));
	  if (ai->port!=12345)
	  {
	    strcat(send, ":");
	    strcat(send, ULto_string(ai->port));
	  }
	  strcat(send, ")\r\n");
	  soc.Puts(soc.SocketFD(), send);
	}
      }
    }
    
    else if (typecmp(command, "who@*"))
    {
      char *h=strchr(command, '@')+1;
      int n=GetMembersNum(who);
      
      if (n!=-1)
      {
	char *_who;
	italk->GetMembers(NULL);
	char host[BUFSIZE];
	sprintf(host, "%s*", h);
	
	AnItalk *ai;
	AnItalk *aib=NULL;
	char send[BUFSIZE];
	sprintf(send, "/p %04d ", n);
	
	while (1)
	{
	  _who=italk->GetMembers(host, &ai);
	  if ((ai!=aib || !_who) && aib)
	  {
	    strcat(send, "(@");
	    strcat(send, firstperiod(aib->hostname));
	    if (aib->port!=12345)
	    {
	      strcat(send, ":");
	      strcat(send, ULto_string(aib->port));
	    }
	    strcat(send, ")\r\n");
	    soc.Puts(soc.SocketFD(), send);
	    sprintf(send, "/p %04d ", n);
	  }
	  if (_who)
	  {
	    strcat(send, firstperiod(_who));
	    strcat(send, " ");
	  }
	  if (!_who) break;
	  aib=ai;
	}
      }
    }
    
    else if (typecmp(command, "m@*") || typecmp(command, "man@*") ||
	     typecmp(command, "h@*") || typecmp(command, "help@*") ||
	     typecmp(command, "v@*") || typecmp(command, "version@*"))
    {
      int n=GetMembersNum(who);
      if (n!=-1)
      {
	char send[BUFSIZE];
	sprintf(send,
		"/p %04d italkpipe \"ѷ\" 0.07 - GANA\r\n"
		"/p %04d w[ho]@[hostname[:port]]      : Who are there ? (You can use '*' or '?' in hostname)\r\n"
		"/p %04d c[onnect]@hostname[:port]    : Connect to \r\n"
		"/p %04d d[isconnect]@hostname[:port] : Disconnect with (You can use '*' or '?' in hostname)\r\n"
		"/p %04d m[an]@, h[elp]@, v[ersion]@  : Show this help.\r\n"
		"/p %04d ... and any command can be send by /p !\r\n"
		, n, n, n, n, n, n);
	soc.Puts(soc.SocketFD(), send);
      }
    }
	
    else if (typecmp(command, "c@*") || typecmp(command, "connect@*"))
    {
      char *h=strchr(command, '@')+1;
      if (italk->Open(h))
      {
	char send[BUFSIZE];
	sprintf(send, "failed to connect@%s\r\n", h);
	italk->SendAll(send, -1);
      }
    }
    
    else if (typecmp(command, "d@*") || typecmp(command, "disconnect@*"))
    {
      italk->Close(strchr(command, '@')+1, soc.SocketFD());
      italk->SendAll("/w\r\n", -1);
    }
  }
  
  return True;
}


void AnItalk::Receive(void)
{
  char buf[BUFSIZE];
  soc.Gets(soc.SocketFD(), buf, BUFSIZE, 15);
  remove_newline(buf);
  
  if (typecmp(buf, "## __*"))
    // ## __ BACK LOG START _____________________
    now_backlog=True;
  else if (typecmp(buf, "## --*"))
    // ## -- BACK LOG END -----------------------
    now_backlog=False;
  else if (!now_backlog)
    // 
  {
    if (typecmp(buf, "(??:??:??)[*] *"))
    {
      if (Command(buf+11, strchr(buf, ']')+2))
      {
	char send[BUFSIZE];
	sprintf(send, "%s\r\n", buf+10);
	italk->SendAll(send, soc.SocketFD());
      }
    }
    
    else if (typecmp(buf, "([*] *"))
    {
      char send[BUFSIZE];
      
      soc.Puts(soc.SocketFD(), "/w\r\n");
      if (port==12345)
	sprintf(send, "%s(@%s)\r\n", buf, firstperiod(hostname));
      else
	sprintf(send, "%s(@%s:%d)\r\n", buf, firstperiod(hostname), port);
      italk->SendAll(send, soc.SocketFD());
    }
    
    else if (typecmp(buf, "#< Message from (????) [*"))
    {
      if (p_mode_who) delete_string(p_mode_who);
      char name[BUFSIZE];
      char *h=strchr(buf+24, ']');
      if (h)
      {
	strncpy(name, buf+24, h-(buf+24));
	name[h-(buf+24)]='\0';
	p_mode_who=new_string(name);
      }
    }
    
    else if (typecmp(buf, "#< *"))
    {
      if (p_mode_who)
      {
	Command(p_mode_who, buf+3);
	delete_string(p_mode_who);
      }
    }
    
    else if (typecmp(buf, "# This *"))
    {
      for (int i=0; i<MAX_MEMBER; i++)
	delete_string(members[i]);
      char *h=strchr(buf, '@')+1;
      char *p=strchr(h, ':');
      char host[BUFSIZE];
      strncpy(host, h, (p-h));
      host[p-h]='\0';
      delete_string(hostname);
      hostname=new_string(host);
      port=atoi(p+1);
    }
    
    else if (typecmp(buf, "# (????) *"))
    {
      for (int i=0; i<MAX_MEMBER; i++)
      {
	if (!members[i])
	{
	  members[i]=new_string(buf+15); // for Newtype_server: 15 / Other : 9
	  members_num[i]=atoi(buf+3);
	  break;
	}
      }
    }
    
    else if (typecmp(buf, "# * users logged in @ *"))
    {
      if (!italkpipe_number)
      {
	for (int i=0; i<MAX_MEMBER; i++)
	  if (members[i])
	    if (0==strncmp("ѷ", members[i], 6))
	      italkpipe_number++;
	if (italkpipe_number==2)
	  italk->Close(soc.SocketFD());
      }
      italk->SendToClientWhoAreHere(-1);
    }
    
  }
}


Italk::Italk(int port)
{
  if (server.Init(SOCKET_STREAM_SERVER, NULL, port, True))
  {
    fprintf(stderr, "error: SocketStream::Init(): \r\n");
    exit(1);
  }
  for (int i=0; i<MAX_FD; i++)
  {
    anitalk[i]=NULL;
    client[i]=False;
  }
  n=0;
  chukei_message_counter=0;
}


Italk::~Italk()
{
  for (int i=0; i<MAX_FD; i++)
    if (anitalk[i])
      delete anitalk[i];
}


char *Italk::chukei_message[]=
{
  "ѷ is alive\r\n",
  "\r\n",
  "ߤ\r\n",
  "Ϥ\r\n",
  "ɤɤ\r\n",
  "ߤ\r\n",
  "italkpipe \"ѷ\" 0.08 - GANA (Modified by Aleph-0)\r\n",
  NULL,
};


char *Italk::GetChukeiMessage(void)
{
  char *cm=chukei_message[chukei_message_counter];
  chukei_message_counter=(chukei_message_counter+1+random()%3)%
    (sizeof(chukei_message)/sizeof(char *));
  if (!cm)
  {
    time_t t=time(NULL);
    return ctime(&t);
  }
  return cm;
}


void Italk::SendToClientWhoAreHere(int f)
{
  for (int i=0; i<MAX_FD; i++)
  {
    if ((f==i || f==-1) && client[i])
    {
      server.Puts(i, "## __ START\r\n");
      char *who;
      GetMembers(NULL);
      AnItalk *ai;
      while (who=GetMembers("*", &ai))
      {
	char send[BUFSIZE];
	sprintf(send, "%04d %s (@%s:%d)\r\n", ai->GetMembersNum(who), who, ai->hostname, ai->port);
	server.Puts(i, send);
      }
      server.Puts(i, "## -- END\r\n");
    }
  }
}


char *Italk::GetMembers(char *host, AnItalk **ai)
{
  if (!host)
  {
    get_members_n=0;
    get_members_host_fd=0;
    return NULL;
  }
  for (;get_members_host_fd<MAX_FD; get_members_host_fd++)
  {
    if (anitalk[get_members_host_fd])
    {
      if (typecmp(anitalk[get_members_host_fd]->hostname, host))
      {
	for (; get_members_n<MAX_MEMBER; get_members_n++)
	  if (anitalk[get_members_host_fd]->members[get_members_n])
	  {
	    if (ai) *ai=anitalk[get_members_host_fd];
	    return anitalk[get_members_host_fd]->members[get_members_n++];
	  }
      }
    }
    get_members_n=0;
  }
  return NULL;
}


void Italk::Close(int fd)
{
  if (anitalk[fd])
  {
    char send[BUFSIZE];
    time_t t=time(NULL);
    
    strcpy(send, "([ѷ] logged out @ ");
    strcat(send, ctime(&t));
    remove_newline(send);
    strcat(send, ")(@");
    strcat(send, anitalk[fd]->hostname);
    if (anitalk[fd]->port!=12345)
    {
      strcat(send, ":");
      strcat(send, ULto_string(anitalk[fd]->port));
    }
    strcat(send, ")\r\n");
    SendAll(send, fd);
    
    delete anitalk[fd];
    anitalk[fd]=NULL;
    n--;
    server.NotSelectThis(fd);
  }
}


void Italk::Close(char *with, int fd)
{
  char *host;
  US port;
  split_host_port(with, host, port);
  char buf[strlen(host)+2];
  strcpy(buf, host);
  strcat(buf, "*");
  
  for (int i=0; i<MAX_FD; i++)
    if (anitalk[i] && n>1 && i!=fd)
      if (typecmp(anitalk[i]->hostname, buf) && anitalk[i]->port==port)
	Close(i);
}


int Italk::Open(char *to)
{
  char send[BUFSIZE];
  sprintf(send, "connecting to %s ...\r\n", to);
  SendAll(send, -1);
  
  AnItalk *tmpitalk=new AnItalk(this);
  int i=tmpitalk->Connect(to);
  if (i==-1) return -1;
  anitalk[i]=tmpitalk;
  
  server.SelectThis(i);
  
  n++;
  return 0;
}



void Italk::SendAll(char *buf, int fd)
{
  for (int i=0; i<MAX_FD; i++)
    if (i!=fd && anitalk[i])
      anitalk[i]->soc.Puts(i, buf);
}


void Italk::Wait(void)
{
  while (n)
  {
    int fd=server.Select(3600);
    if (fd<0) continue;
    
    if (anitalk[fd%MAX_FD])
    {
      if (fd<MAX_FD) // ǡ褿
	anitalk[fd]->Receive();
      else if (fd<MAX_FD*3) // italk С󤷤
	Close(fd%MAX_FD);
    }
    
    else
    {
      if (fd<MAX_FD) // ǡ褿
      {
	if (client[fd])
	{
	  char buf[BUFSIZE];
	  if (server.Gets(fd, buf, BUFSIZE, 15)>0)
	  {
	    remove_newline(buf);
	    if (typecmp(buf, "^[*] ping ѷ"))
	    {
	      char *send=GetChukeiMessage();
	      SendAll(send, -1);
	    }
	    else if (typecmp(buf, "^[*] ping *"))
	    {
	      char *buf_who=strchr(buf, ']')+7;
	      char *_who;
	      GetMembers(NULL);
	      AnItalk *ai, *aib=NULL;
	      while (_who=GetMembers("*", &ai))
	      {
		if (ai!=aib)
		{
		  int n=ai->GetMembersNum(buf_who);
		  if (n!=-1)
		  {
		    char send[BUFSIZE];
		    sprintf(send, "/p %04d %s\r\n", n, buf+1);
		    ai->soc.Puts(ai->soc.SocketFD(), send);
		  }
		  aib=ai;
		}
	      }
	    }
	  }
	  else
	    SendToClientWhoAreHere(fd);
	}
      }
      else if (fd<MAX_FD*2) // new connect
      {
	client[fd%MAX_FD]=True;
	SendToClientWhoAreHere(fd%MAX_FD);
      }
      else if (fd<MAX_FD*3) // connection closed
      {
	if (client[fd%MAX_FD])
	  client[fd%MAX_FD]=False;
      }
    }
    
  }
}


int main(int argc, char *argv[])
{
  setlocale(LC_ALL, "");
  signal(SIGPIPE, SIG_IGN);
  
  int port=12344;
  if (argc>2)
  {
    if (strcmp("-p", argv[1])==0)
    {
      port=atoi(argv[2]);
      argc-=2;
      argv+=2;
    }
  }
  Italk italk(port);
  if (argc==1) italk.Open("ecc-lx00.hongo.ecc.u-tokyo.ac.jp:12345");
  for (int i=1; i<argc; i++) italk.Open(argv[i]);
  italk.Wait();
  return 0;
}
